Index: branches/2972_PDPRowSelect/HeuristicLab.Random/3.3/RandomEnumerable.cs
===================================================================
--- branches/2972_PDPRowSelect/HeuristicLab.Random/3.3/RandomEnumerable.cs	(revision 16517)
+++ branches/2972_PDPRowSelect/HeuristicLab.Random/3.3/RandomEnumerable.cs	(revision 16518)
@@ -202,5 +202,5 @@
         var cur = list.First;
         double ball = cur.Value.Item2, sum = random.NextDouble() * total; // assert: sum < total. When there is only one item remaining: sum < ball
-        while (ball < sum) {
+        while (ball < sum && cur.Next != null) {
           cur = cur.Next;
           ball += cur.Value.Item2;
Index: branches/2972_PDPRowSelect/HeuristicLab.Scripting.Views/3.3/ScriptView.Designer.cs
===================================================================
--- branches/2972_PDPRowSelect/HeuristicLab.Scripting.Views/3.3/ScriptView.Designer.cs	(revision 16517)
+++ branches/2972_PDPRowSelect/HeuristicLab.Scripting.Views/3.3/ScriptView.Designer.cs	(revision 16518)
@@ -118,6 +118,6 @@
       // infoTabControl
       // 
-      this.infoTabControl.Anchor = ((System.Windows.Forms.AnchorStyles)((((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom) 
-            | System.Windows.Forms.AnchorStyles.Left) 
+      this.infoTabControl.Anchor = ((System.Windows.Forms.AnchorStyles)((((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom)
+            | System.Windows.Forms.AnchorStyles.Left)
             | System.Windows.Forms.AnchorStyles.Right)));
       this.infoTabControl.Controls.Add(this.outputTabPage);
@@ -131,4 +131,5 @@
       // outputTabPage
       // 
+      this.outputTabPage.BackColor = System.Drawing.SystemColors.Window;
       this.outputTabPage.Controls.Add(this.outputTextBox);
       this.outputTabPage.Location = new System.Drawing.Point(4, 22);
@@ -138,5 +139,4 @@
       this.outputTabPage.TabIndex = 1;
       this.outputTabPage.Text = "Output";
-      this.outputTabPage.UseVisualStyleBackColor = true;
       // 
       // outputTextBox
@@ -155,4 +155,5 @@
       // errorListTabPage
       // 
+      this.errorListTabPage.BackColor = System.Drawing.SystemColors.Window;
       this.errorListTabPage.Controls.Add(this.errorListView);
       this.errorListTabPage.Location = new System.Drawing.Point(4, 22);
@@ -162,5 +163,4 @@
       this.errorListTabPage.TabIndex = 0;
       this.errorListTabPage.Text = "Error List";
-      this.errorListTabPage.UseVisualStyleBackColor = true;
       // 
       // errorListView
Index: branches/2972_PDPRowSelect/HeuristicLab.Tests/HeuristicLab.Problems.DataAnalysis.Symbolic-3.4/DeriveTest.cs
===================================================================
--- branches/2972_PDPRowSelect/HeuristicLab.Tests/HeuristicLab.Problems.DataAnalysis.Symbolic-3.4/DeriveTest.cs	(revision 16517)
+++ branches/2972_PDPRowSelect/HeuristicLab.Tests/HeuristicLab.Problems.DataAnalysis.Symbolic-3.4/DeriveTest.cs	(revision 16518)
@@ -60,4 +60,6 @@
       Assert.AreEqual("(1 / (SQR(COS((3*'x'))) * 0.333333333333333))", Derive("tan(3*x)", "x")); // diff(tan(f(x)), x) = 1.0 / cos²(f(x)), simplifier puts constant factor into the denominator
 
+      Assert.AreEqual("0", Derive("(a+b)/(x+SQR(x))", "y")); // df(a,b,x) / dy = 0
+
       {
         // special case: Inv(x) using only one argument to the division symbol
@@ -114,8 +116,8 @@
 
         Assert.AreEqual("(('y' * 'z' * 60) / (SQR('y') * SQR('z') * 400))", // actually 3 / (4y  5z) but simplifier is not smart enough to cancel numerator and denominator
-                                                                             // 60 y z / y² z² 20² == 6 / y z 40 == 3 / y z 20
+                                                                            // 60 y z / y² z² 20² == 6 / y z 40 == 3 / y z 20
           formatter.Format(DerivativeCalculator.Derive(t, "x")));
         Assert.AreEqual("(('x' * 'z' * (-60)) / (SQR('y') * SQR('z') * 400))", // actually 3x * -(4 5 z) / (4y 5z)² = -3x / (20 y² z)
-                                                                         // -3 4 5 x z / 4² y² 5² z² = -60 x z / 20² z² y² ==    -60 x z / y² z² 20² 
+                                                                               // -3 4 5 x z / 4² y² 5² z² = -60 x z / 20² z² y² ==    -60 x z / y² z² 20² 
           formatter.Format(DerivativeCalculator.Derive(t, "y")));
         Assert.AreEqual("(('x' * 'y' * (-60)) / (SQR('y') * SQR('z') * 400))",
